# Copyright (c) 2008-2010 oc2pus
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments to toni@links2linux.de

# norootforbuild

%define _prefix		/usr
%define _with_doc	1
%define _osg_so_nr	65
%define _opt_so_nr	11

Name:			OpenSceneGraph
URL:			http://www.openscenegraph.org/projects/osg
Summary:		Open source high performance 3D graphics toolkit
License:		OpenSceneGraph Public License
Version:		2.8.3
Release:		0.pm.2.60
BuildRoot:		%{_tmppath}/%{name}-%{version}-build
Group:			Productivity/Graphics/Other
Source:			http://www.openscenegraph.org/downloads/developer_releases/%{name}-%{version}.zip
Source1:		%{name}.png
Source90:		%{name}-rpmlintrc
Patch0:			%{name}-gcc43.patch
Patch1:			%{name}-ffmpeg.patch
BuildRequires:	cmake
BuildRequires:	curl-devel
BuildRequires:	dos2unix
BuildRequires:	fdupes
BuildRequires:	fltk-devel
BuildRequires:	freetype2-devel
BuildRequires:	freeglut-devel
BuildRequires:	gcc-c++
BuildRequires:	giflib-devel
BuildRequires:	gtkglext-devel
%if "%{_with_doc}" == "1"
BuildRequires:	doxygen
BuildRequires:	graphviz
%endif
BuildRequires:	libffmpeg_oldabi-devel
BuildRequires:	libgdal-devel xerces-j2
BuildRequires:	libjpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	libpoppler-glib-devel
BuildRequires:	librsvg-devel
BuildRequires:	libtiff-devel
BuildRequires:	libxine-devel libspeex1
%if %suse_version >= 1140
BuildRequires:	mozilla-xulrunner20-devel
%else
BuildRequires:	mozilla-xulrunner192-devel
%endif
BuildRequires:	openal-soft-devel
BuildRequires:	OpenEXR-devel
BuildRequires:	phonon-devel
BuildRequires:	qt-devel
BuildRequires:	SDL-devel
BuildRequires:	unzip
BuildRequires:	update-desktop-files
%if %suse_version >= 1140
BuildRequires:	wxWidgets-devel
%else
BuildRequires:	wxGTK-devel
%endif
BuildRequires:	zlib-devel

%description
The OpenSceneGraph is an OpenSource, cross platform graphics
toolkit for the development of high performance graphics
applications such as flight simulators, games, virtual reality
and scientific visualization. Based around the concept of a
SceneGraph, it provides an object oriented framework on top of
OpenGL freeing the developer from implementing and optimizing
low level graphics calls, and provides many additional
utilities for rapid development of graphics applications.

%package -n libOpenSceneGraph%{_osg_so_nr}
Summary:	Shared libraries for OpenSceneGraph
Group:		System/Libraries
Provides:	libOpenSceneGraph25 = 2.2.0
Obsoletes:	libOpenSceneGraph25 < 2.2.0
Provides:	libOpenSceneGraph35 = 2.4.0
Obsoletes:	libOpenSceneGraph35 < 2.4.0
Provides:	libOpenSceneGraph44 = 2.6.0
Obsoletes:	libOpenSceneGraph44 < 2.6.0
Provides:	libOpenSceneGraph48 = 2.6.1
Obsoletes:	libOpenSceneGraph48 < 2.6.1
Provides:	libOpenSceneGraph55 = 2.8.2
Obsoletes:	libOpenSceneGraph55 < 2.8.2

%description -n libOpenSceneGraph%{_osg_so_nr}
The OpenSceneGraph is an OpenSource, cross platform graphics
toolkit for the development of high performance graphics
applications such as flight simulators, games, virtual reality
and scientific visualization. Based around the concept of a
SceneGraph, it provides an object oriented framework on top of
OpenGL freeing the developer from implementing and optimizing
low level graphics calls, and provides many additional
utilities for rapid development of graphics applications.

This package contains the shared libraries for OpenSceneGraph.

%package -n libOpenSceneGraph-devel
Summary:	OpenSceneGraph development files
Group:		Development/Libraries/C and C++
Requires:	libOpenSceneGraph%{_osg_so_nr} = %{version}
Requires:	libOpenThreads-devel = %{version}
Requires:	curl-devel
Requires:	freetype2-devel
Requires:	freeglut-devel
Requires:	giflib-devel
Requires:	gtkglext-devel
Requires:	libgdal-devel
Requires:	libffmpeg-devel
Requires:	libjpeg-devel
Requires:	libpng-devel
%if %suse_version >= 1100
Requires:	libpoppler-glib-devel
%endif
Requires:	librsvg-devel
Requires:	libtiff-devel
Requires:	libxine-devel
%if %suse_version >= 1110
Requires:	openal-soft-devel
%else
Requires:	openal-devel
%endif
Requires:	qt-devel
Requires:	SDL-devel

%description -n libOpenSceneGraph-devel
The OpenSceneGraph is an OpenSource, cross platform graphics
toolkit for the development of high performance graphics
applications such as flight simulators, games, virtual reality
and scientific visualization. Based around the concept of a
SceneGraph, it provides an object oriented framework on top of
OpenGL freeing the developer from implementing and optimizing
low level graphics calls, and provides many additional
utilities for rapid development of graphics applications.

This package contains the header and development files for
OpenSceneGraph.

%package -n libOpenThreads%{_opt_so_nr}
Summary:	Shared libraries for OpenSceneGraph
Group:		System/Libraries
Provides:	libOpenThreads9 = 2.2.0
Obsoletes:	libOpenThreads9 < 2.2.0
Provides:	libOpenThreads10 = 2.4.0
Obsoletes:	libOpenThreads10 < 2.4.0

%description -n libOpenThreads%{_opt_so_nr}
The OpenSceneGraph is an OpenSource, cross platform graphics
toolkit for the development of high performance graphics
applications such as flight simulators, games, virtual reality
and scientific visualization. Based around the concept of a
SceneGraph, it provides an object oriented framework on top of
OpenGL freeing the developer from implementing and optimizing
low level graphics calls, and provides many additional
utilities for rapid development of graphics applications.

This package contains the shared libraries for OpenSceneGraph.

%package -n libOpenThreads-devel
Summary:	OpenSceneGraph development files
Group:		Development/Libraries/C and C++
Requires:	libOpenThreads%{_opt_so_nr} = %{version}
Requires:	curl-devel
Requires:	freetype2-devel
Requires:	freeglut-devel
Requires:	giflib-devel
Requires:	libjpeg-devel
%if %suse_version >= 1100
Requires:	libpoppler-glib-devel
%endif
Requires:	libpng-devel
Requires:	libtiff-devel
Requires:	libxine-devel
Requires:	qt-devel
Requires:	SDL-devel

%description -n libOpenThreads-devel
The OpenSceneGraph is an OpenSource, cross platform graphics
toolkit for the development of high performance graphics
applications such as flight simulators, games, virtual reality
and scientific visualization. Based around the concept of a
SceneGraph, it provides an object oriented framework on top of
OpenGL freeing the developer from implementing and optimizing
low level graphics calls, and provides many additional
utilities for rapid development of graphics applications.

This package contains the header and development files for
OpenSceneGraph.

%package plugins
Summary:	Plugins for OpenSceneGraph
Group:		Productivity/Graphics/Other

%description plugins
The OpenSceneGraph is an OpenSource, cross platform graphics
toolkit for the development of high performance graphics
applications such as flight simulators, games, virtual reality
and scientific visualization. Based around the concept of a
SceneGraph, it provides an object oriented framework on top of
OpenGL freeing the developer from implementing and optimizing
low level graphics calls, and provides many additional
utilities for rapid development of graphics applications.

This package contains some plugins for OpenSceneGraph.

%package examples
Summary:	Example applications for OpenSceneGraph
Group:		Productivity/Graphics/Other

%description examples
The OpenSceneGraph is an OpenSource, cross platform graphics
toolkit for the development of high performance graphics
applications such as flight simulators, games, virtual reality
and scientific visualization. Based around the concept of a
SceneGraph, it provides an object oriented framework on top of
OpenGL freeing the developer from implementing and optimizing
low level graphics calls, and provides many additional
utilities for rapid development of graphics applications.

This package contains some example applications for OpenSceneGraph.

%package viewer-sdl
Summary:	Example applications for OpenSceneGraph
Group:		Productivity/Graphics/Other

%description viewer-sdl
The OpenSceneGraph is an OpenSource, cross platform graphics
toolkit for the development of high performance graphics
applications such as flight simulators, games, virtual reality
and scientific visualization. Based around the concept of a
SceneGraph, it provides an object oriented framework on top of
OpenGL freeing the developer from implementing and optimizing
low level graphics calls, and provides many additional
utilities for rapid development of graphics applications.

This package contains a SDL based viewer for OpenSceneGraph.

%package viewer-fltk
Summary:	Example applications for OpenSceneGraph
Group:		Productivity/Graphics/Other

%description viewer-fltk
The OpenSceneGraph is an OpenSource, cross platform graphics
toolkit for the development of high performance graphics
applications such as flight simulators, games, virtual reality
and scientific visualization. Based around the concept of a
SceneGraph, it provides an object oriented framework on top of
OpenGL freeing the developer from implementing and optimizing
low level graphics calls, and provides many additional
utilities for rapid development of graphics applications.

This package contains a FLTK based viewer for OpenSceneGraph.

%package viewer-qt
Summary:	Example applications for OpenSceneGraph
Group:		Productivity/Graphics/Other

%description viewer-qt
The OpenSceneGraph is an OpenSource, cross platform graphics
toolkit for the development of high performance graphics
applications such as flight simulators, games, virtual reality
and scientific visualization. Based around the concept of a
SceneGraph, it provides an object oriented framework on top of
OpenGL freeing the developer from implementing and optimizing
low level graphics calls, and provides many additional
utilities for rapid development of graphics applications.

This package contains a QT based viewer for OpenSceneGraph.

%package viewer-wx
Summary:	Example applications for OpenSceneGraph
Group:		Productivity/Graphics/Other

%description viewer-wx
The OpenSceneGraph is an OpenSource, cross platform graphics
toolkit for the development of high performance graphics
applications such as flight simulators, games, virtual reality
and scientific visualization. Based around the concept of a
SceneGraph, it provides an object oriented framework on top of
OpenGL freeing the developer from implementing and optimizing
low level graphics calls, and provides many additional
utilities for rapid development of graphics applications.

This package contains a wxWidgets based viewer for OpenSceneGraph.

%package doc
Summary:	Documentation OpenSceneGraph
Group:		Documentation/HTML

%description doc
The OpenSceneGraph is an OpenSource, cross platform graphics
toolkit for the development of high performance graphics
applications such as flight simulators, games, virtual reality
and scientific visualization. Based around the concept of a
SceneGraph, it provides an object oriented framework on top of
OpenGL freeing the developer from implementing and optimizing
low level graphics calls, and provides many additional
utilities for rapid development of graphics applications.

This package contains the documentation for OpenSceneGraph.



%prep
%setup -q -n %{name}-%{version}
#%patch0 -p1
%patch1 -p1
/bin/cat /usr/src/packages/SOURCES/OpenSceneGraph-gcc43.patch | /usr/bin/patch -s -p1

dos2unix     *.txt ChangeLog
%__chmod 644 *.txt ChangeLog

%build
export CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing -D__STDC_CONSTANT_MACROS -UGTK_DISABLE_DEPRECATED"
export CXXFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing -D__STDC_CONSTANT_MACROS -UGTK_DISABLE_DEPRECATED"
cmake \
	-DCMAKE_INSTALL_PREFIX=%{_prefix} \
	-DBUILD_OSG_EXAMPLES=ON \
	-DBUILD_OSG_PLUGINS=ON \
%if "%{_with_doc}" == "1"
	-DBUILD_DOCUMENTATION=ON \
%else
	-DBUILD_DOCUMENTATION=OFF \
%endif
	-DBUILD_OSG_WRAPPER=ON \
	-DBUILD_OSG_APPLICATIONS=ON \
	-DCMAKE_BUILD_TYPE=Release \
	-DDYNAMIC_OPENSCENEGRAPH=ON \
	-DDYNAMIC_OPENTHREADS=ON

%__make %{?jobs:-j %jobs}
%__make doc_openscenegraph doc_openthreads

%install
%makeinstall

%__install -dm 755 %{buildroot}%{_libdir}/pkgconfig
%__install -m 644 packaging/pkgconfig/*.pc \
	%{buildroot}%{_libdir}/pkgconfig

# move sample applications from %{_datadir}/%{name}/bin to %{_bindir}
%__install -dm 755 %{buildroot}%{_bindir}
%__mv %{buildroot}%{_datadir}/%{name}/bin/* \
	%{buildroot}%{_bindir}
%__rm -r %{buildroot}%{_datadir}/%{name}

# icon
%__install -dm 755 %{buildroot}%{_datadir}/pixmaps
%__install -m 644 %{SOURCE1} \
	%{buildroot}%{_datadir}/pixmaps

# menu-entry
%__cat > %{name}.desktop << EOF
[Desktop Entry]
Type=Application
Name=OpenSceneGraph Viewer
GenericName=OpenSceneGraph Viewer
Comment=The OpenSceneGraph - a cross platform graphics toolkit
Exec=osgviewer
Icon=%{name}
Encoding=UTF-8
Categories=Graphics;Viewer;
EOF
%suse_update_desktop_file -i %{name} Graphics Viewer

# done by doc-macros
%__rm -r %{buildroot}/usr/doc
%fdupes -s doc/OpenSceneGraphReferenceDocs
%fdupes -s doc/OpenThreadsReferenceDocs

%clean
[ -d "%{buildroot}" -a "%{buildroot}" != "" ] && %__rm -rf "%{buildroot}"

%post -n libOpenSceneGraph%{_osg_so_nr} -p /sbin/ldconfig
%postun -n libOpenSceneGraph%{_osg_so_nr} -p /sbin/ldconfig

%post -n libOpenThreads%{_opt_so_nr} -p /sbin/ldconfig
%postun -n libOpenThreads%{_opt_so_nr} -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc AUTHORS.txt LICENSE.txt NEWS.txt README.txt ChangeLog
%{_bindir}/osgarchive
%{_bindir}/osgconv
%{_bindir}/osgversion
%{_bindir}/osgviewer
%{_bindir}/osgviewerGTK
%{_bindir}/osgviewerGLUT
%{_datadir}/pixmaps/%{name}.png
%{_datadir}/applications/%{name}.desktop

%files viewer-qt
%defattr(-,root,root)
%{_bindir}/osgviewerQT

%files viewer-fltk
%defattr(-,root,root)
%{_bindir}/osgviewerFLTK

%files viewer-sdl
%defattr(-,root,root)
%{_bindir}/osgviewerSDL

%files viewer-wx
%defattr(-,root,root)
%{_bindir}/osgviewerWX

%files plugins
%defattr(-,root,root)
%dir %{_libdir}/osgPlugins-%{version}
%{_libdir}/osgPlugins-%{version}/*

%files examples
%defattr(-,root,root)
%exclude %{_bindir}/osgarchive
%exclude %{_bindir}/osgconv
%exclude %{_bindir}/osgversion
%exclude %{_bindir}/osgviewer*
%{_bindir}/*

%files -n libOpenSceneGraph%{_osg_so_nr}
%defattr(-,root,root)
%{_libdir}/libosg.so.*
%{_libdir}/libosgAnimation.so.*
%{_libdir}/libosgDB.so.*
%{_libdir}/libosgFX.so.*
%{_libdir}/libosgGA.so.*
%{_libdir}/libosgManipulator.so.*
%{_libdir}/libosgParticle.so.*
%{_libdir}/libosgShadow.so.*
%{_libdir}/libosgSim.so.*
%{_libdir}/libosgTerrain.so.*
%{_libdir}/libosgText.so.*
%{_libdir}/libosgUtil.so.*
%{_libdir}/libosgVolume.so.*
%{_libdir}/libosgViewer.so.*
%{_libdir}/libosgWidget.so.*

%files -n libOpenSceneGraph-devel
%defattr(-,root,root)
%dir %{_includedir}/osg
%{_includedir}/osg/*
%dir %{_includedir}/osgAnimation
%{_includedir}/osgAnimation/*
%dir %{_includedir}/osgDB
%{_includedir}/osgDB/*
%dir %{_includedir}/osgFX
%{_includedir}/osgFX/*
%dir %{_includedir}/osgGA
%{_includedir}/osgGA/*
%dir %{_includedir}/osgManipulator
%{_includedir}/osgManipulator/*
%dir %{_includedir}/osgParticle
%{_includedir}/osgParticle/*
%dir %{_includedir}/osgShadow
%{_includedir}/osgShadow/*
%dir %{_includedir}/osgSim
%{_includedir}/osgSim/*
%dir %{_includedir}/osgTerrain
%{_includedir}/osgTerrain/*
%dir %{_includedir}/osgText
%{_includedir}/osgText/*
%dir %{_includedir}/osgUtil
%{_includedir}/osgUtil/*
%dir %{_includedir}/osgViewer
%{_includedir}/osgViewer/*
%dir %{_includedir}/osgVolume
%{_includedir}/osgVolume/*
%dir %{_includedir}/osgWidget
%{_includedir}/osgWidget/*

%{_libdir}/libosg.so
%{_libdir}/libosgAnimation.so
%{_libdir}/libosgDB.so
%{_libdir}/libosgFX.so
%{_libdir}/libosgGA.so
%{_libdir}/libosgManipulator.so
%{_libdir}/libosgParticle.so
%{_libdir}/libosgShadow.so
%{_libdir}/libosgSim.so
%{_libdir}/libosgTerrain.so
%{_libdir}/libosgText.so
%{_libdir}/libosgUtil.so
%{_libdir}/libosgViewer.so
%{_libdir}/libosgVolume.so
%{_libdir}/libosgWidget.so
%{_libdir}/pkgconfig/openscenegraph.pc

%files -n libOpenThreads%{_opt_so_nr}
%defattr(-,root,root)
%{_libdir}/libOpenThreads.so.*

%files -n libOpenThreads-devel
%defattr(-,root,root)
%dir %{_includedir}/OpenThreads
%{_includedir}/OpenThreads/*
%{_libdir}/libOpenThreads.so
%{_libdir}/pkgconfig/openthreads.pc

%files doc
%defattr(-,root,root)
%doc doc/OpenSceneGraphReferenceDocs
%doc doc/OpenThreadsReferenceDocs

%changelog
* Tue Apr 13 2010 Toni Graffy <toni@links2linux.de> 2.8.3-0.pm.1
- update to 2.8.3
- added docs
- added ffmpeg based plugins
- added gdal based plugins
- split-off viewers (FLTK, QT, SDL, WX) to keep dependencies smaller
- new sonames ==> libOpenSceneGraph65
* Tue Oct 27 2009 Toni Graffy <toni@links2linux.de> 2.8.2-0.pm.1
- update to 2.8.2
* Thu May 21 2009 Toni Graffy <toni@links2linux.de> 2.8.1-0.pm.1
- update to 2.8.1
* Fri Feb 13 2009 Toni Graffy <toni@links2linux.de> 2.8.0-0.pm.1
- update to 2.8.0
- new sonames ==> libOpenSceneGraph55
* Tue Oct 07 2008 Toni Graffy <toni@links2linux.de> 2.6.1-0.pm.1
- update to 2.6.1
- new sonames ==> libOpenSceneGraph48
* Fri Aug 08 2008 Toni Graffy <toni@links2linux.de> 2.6.0-0.pm.1
- update to 2.6.0
- new sonames ==> libOpenThreads11, libOpenSceneGraph44
* Mon May 12 2008 Toni Graffy <toni@links2linux.de> 2.4.0-0.pm.1
- update to 2.4.0
- new sonames ==> libOpenThreads10, libOpenSceneGraph35
* Sat Feb 02 2008 Toni Graffy <toni@links2linux.de> 2.2.0-0.pm.1
- initial version 2.2
